#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include "pattern_match.h"



/* public */



int ABind (char *AB, char c)
{
  return(strchr(AB,c)-AB);
}



void calc_dist(char *AB, int absize, int *N, int *M, char **vect, int depth_s, 
               int L, int m, char **ds_ptr)
{
  int len, achou, ind;
  int i, j, k;
  char *p;
  
 
  for (i=0;i<absize;i++)
    {
      N[i] = 0;
      M[i] = 0;  
    }
  N[absize] = 0;
  if (depth_s == 0)
    {
      for (i=1; i<=m; i++)
	{
	  p = ds_ptr[i];
	  len = strlen(p);
	  for (j=0;j<len;j++)
	    ++N[ABind(AB,p[j])];
	  --M[ABind(AB,p[len-1])];
	}
      for (i=0; i<absize; i++)
	{
	  if ( (M[i] += N[i]) >= 0 );
	  else M[i] = 0; 
	  N[absize] += N[i];
	}
      return;
    }
  ind = L-depth_s;
  for (i=1; i<=m; i++)
    {
      p = ds_ptr[i];
      len = strlen(p);
      for (j=0;j<(len-depth_s);j++)
	{
	  achou = 1;
	  k = 0;
	  while (k < depth_s)
	    {  
	      if (strchr(vect[ind+k],p[j+k]) == NULL)
		{
		  achou = 0;
		  break;
		}
	      k++;
	    }
	  if (achou)
	    {
	      ++N[ABind(AB,p[j+k])];
	      if (j-1 > 0)
		++M[ABind(AB,p[j-1])];
	    }
	} 
    }
  for (i=0;i<absize;i++)
    N[absize] += N[i]; 
  return; 
}

