#ifndef _queue_h
#define _queue_h

typedef struct q_struct {
  int key;
  int depth_s;
  char **v;
  struct q_struct *next; } q_node;

typedef q_node *q_type;


/* depth_s is the length of the sparse context s */


/* public functions */

q_type make_empty_queue ();

int not_empty_queue (q_type q);

void enqueue (q_type *q, int key, int depth_s, int L, char **vect, int absize);

void dequeue  (q_type *q, int *key, int *depth_s, int L, char **vect, char *c);
/* dequeues first element of (*q). Assumes non empty queue! */
/* s and seq are pre-allocated adequately */

#endif /*queue_h */

