
#ifndef _treedef_h
#define _treedef_h

typedef struct spst_struct {
  char *label;
  int *dist;
  struct spst_struct **sonsp; } spst_node;

typedef spst_node *spst_type;


/* public functions */


spst_type make_root_node(int absize, int *N);

spst_type make_spst_node (int absize, char *s, int *N);

void free_spst_node (spst_type Tp, int absize);

spst_type traverse_spst(int absize, spst_type T, char **vect, int depth_s, int L);

spst_type search_spst(int absize, spst_type T, char *s, int *lri);

void predict_entry (int absize, char *AB, spst_type T, char *S, double gam_min, \
                    FILE *sfp, char *D, int n_mean);


#endif /*_treedef_h */

